{---------------------------------------------------------------------------------------------------------------------

     ContextMenuEx and DropSourceEx component version 2.05

     (c)1997-1998 by HISHIAMAZON All Rights Reserved.

     http://www2s.biglobe.ne.jp/~ken_in/
     ken_fu@mx4.meshnet.or.jp

     Freeware - compiles under Delphi 3 or 3.1
     [  Windows 98 3 ,  Windows 95 ,  Windows NT4.0 / IE 4 Ή ]

----------------------------------------------------------------------------------------------------------------------}

unit DRPCOMEX;

interface

uses
  Windows, Messages, SysUtils, Classes,  Controls, Forms, ShellApi ,Menus,
  ShlObj, ActiveX, Dialogs;

const
  ID_SENDTO_FIRST      =  WM_USER + 501;
  ID_SENDTO_LAST       =  WM_USER + 599;
  CK_MENU_SENDTO       =  '(&N)';
  CK_MENU_IE4_SENDTO   =  '(&T)';
  CK_MENU_PASTE        =  '(&P)';
  CK_MENU_SENDTO_INDEX =  5;
  CK_MENU_PASTE_INDEX  =  9;
  CMIDCMD_LINK         =  17;
  CMIDCMD_DELETE       =  18;
  CMIDCMD_PROPERTIES   =  20;
  CMIDCMD_CUT          =  25;
  CMIDCMD_COPY         =  26;
  CMIDCMD_PASTE        =  27;
  MAX_SENDTO           =  99;
  MAX_PIDL             =  1024;

  DRPCOMEXVersion      =  '2.05';



type  
  TcmCmdType = (ctLink, ctDelete, ctProperties, ctCut, ctCopy, ctPaste);

   {  ContextMenuEx class  }

  TContextMenuEx = class(TComponent)
  private
    FFileNames: TStringList;
    function isMenu(hcnMenu: HMENU; ckMenu: string; index: Integer): integer;
    procedure SetFileNames(Value: TStringList);
  public
    function ContextMenu(OwnerHandle: HWND; lpsf: IShellFolder; lpi: PItemIDList; ipi: integer; p:TPoint): BOOL;
    function CMCommand(OwnerHandle: HWND; lpsf: IShellFolder; lpi: PItemIDList; p:TPoint; idCmd: TcmCmdType): BOOL;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function DoMenu(OwnerHandle: HWND; const Path: string; X, Y: Integer): BOOL;
    function DoMenuEx(OwnerHandle: HWND; X, Y: Integer): BOOL;
    function quickCommand(OwnerHandle: HWND; const Path: string; X, Y: Integer; qCmd: TcmCmdType): BOOL;
  published
    property CMFileName: TStringList read FFileNames write SetFileNames;
  end;


   { TDropSourceEx class }

  TDropSourceEx = class(TComponent)
  private
    FFileNames: TStringList;
    procedure SetFileNames(Value: TStringList);
  public
    procedure DoDropSource(OwnerHandle: HWND; lpsf: IShellFolder;
                           lpi: PItemIDList; ipi: integer);
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure DoDrop(OwnerHandle: HWND; const Path: string);
    procedure DoDropEx(OwnerHandle: HWND);
  published
    property DSFileName: TStringList read FFileNames write SetFileNames;
  end;

function GetData(const lpifq: PItemIDList; var lpsf: IShellFolder; var lpi: PItemIDList): BOOL;
function GetDataEx(cu: integer; var lpsf: IShellFolder; var arlpi: PItemIDList; FFileNames: TStringList): BOOL;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TContextMenuEx]);
  RegisterComponents('Samples', [TDropSourceEx]);
end;

    {  pidl function  }

function Next(pidl: PItemIdList): PItemIDList;
var
  lpMem: PChar;
begin
  lpMem:= PChar(pidl);
  inc(lpMem,integer(pidl^.mkid.cb));
  Result:= PItemIDList(lpmem);
end;

function GetItemCount(pidl: PItemIDList): UINT;
begin
  Result:= 0;
  if Assigned(pidl) then begin
    while pidl^.mkid.cb <> 0 do begin
      inc(Result);
      pidl:= Next(pidl);
    end;
  end;
end;

function GetSize(pidl: PItemIDList): UINT;
begin
  Result:= 0;
  if Assigned(pidl) then begin
    inc(Result, sizeof(pidl^.mkid.cb));
    while pidl^.mkid.cb <> 0 do begin
      inc(Result, integer(pidl^.mkid.cb));
      pidl:= Next(pidl);
    end;
  end;
end;

function pidlCreate(cbSize: UINT): PItemIDList;
var
  ppmem: IMalloc;
begin
  Result:= nil;
  if FAILED(SHGetMalloc(ppmem)) then exit;
  Result:= PItemIDList(ppmem.Alloc(cbSize));
  if Result <> nil then
    FillChar(Result^,cbSize,0);
end;

function ConcatPidls(pidl1, pidl2: PItemIDList): PItemIDList;
type
  BytePtr = ^Byte;
var
  cb1, cb2: UINT;
begin
  if pidl1 <> nil then
    cb1:= GetSize(pidl1)-SizeOf(pidl1^.mkid.cb) else
    cb1:= 0;
  cb2:= GetSize(pidl2);
  Result:= pidlCreate(cb1 + cb2);
  if Assigned(Result) then begin
    if pidl1<>nil then
      Move(pidl1^, Result^, cb1);
    Move(pidl2^, BytePtr(Integer(Result)+cb1)^, cb2);
  end;
end;

function CopyItemID(pidl: PItemIDList): PItemIDList;
var
  cb: UINT;
begin
  Result:= nil;
  if Assigned(pidl) then begin
    cb:= (pidl^.mkid.cb+sizeof(pidl^.mkid.cb));
    Result:= pidlCreate(cb);
    if Assigned(Result) then
      Move(pidl^, Result^, pidl^.mkid.cb);
  end;
end;

function GetNextItemID(pidl: PItemIDList):PItemIDList;
type
  BytePtr = ^Byte;
var
  cb: integer;
begin
  Result:= nil;
  cb:= Integer(pidl^.mkid.cb);
  if cb <> 0 then begin
    inc(BytePtr(pidl),cb);
    if pidl^.mkid.cb <> 0 then
      Result:= pidl;
  end;
end;

function GetNames(lpsf: IShellFolder; lpi: PItemIDList; dwFlags: DWORD;
                  var szFriendlyName: string): BOOL;
type
  BytePtr = ^Byte;
var
  str: TStrRet;
begin
  Result:= FALSE;
  if NOERROR <> lpsf.GetDisplayNameOf(lpi, dwFlags, str) then exit;
  case str.uType of
    STRRET_WSTR  :
      begin
        szFriendlyName:= WideCharToString(str.polestr);
          {  Add to version 2.05  }
        CoTaskMemFree(str.polestr);
      end;
    STRRET_CSTR  :
      szFriendlyName:= string(str.cStr);
    STRRET_OFFSET:
      begin
        inc(BytePtr(lpi),str.uoffset);
        szFriendlyName:= string(pchar(lpi));
      end;
  end;
  Result:= TRUE;
end;

function GetFullyQualPidl(lpsf: IShellFolder; const lpi: PItemIDList): PItemIDList;
var
  szBuff: string;
  szOleStr: POleStr;
  lpsfDeskTop: IShellFolder;
  lpifq: PItemIDList;
  ulEaten, ulAttribs: ULONG;
  hr: HResult;
begin
  Result:= nil;
  if FALSE = GetNames(lpsf, lpi, SHGDN_FORPARSING, szBuff) then exit;
  if FAILED(SHGetDesktopFolder(lpsfDeskTop)) then Exit;
  szOleStr:= StringToOleStr(szBuff);
  hr:= lpsfDeskTop.ParseDisplayName(0, nil, szOleStr, ulEaten, lpifq, ulAttribs);
  SysFreeString(szOleStr);
  if SUCCEEDED(hr) then
    Result:= lpifq;
end;

function GetPidlfqFromPath(const Path: string): PItemIDList;
var
  swPath: WideString;
  lpsfDeskTop: IShellFolder;
  lpifq: PItemIDList;
  ulEaten, ulAttribs: ULONG;
begin
  Result:= nil;
  if FAILED(SHGetDesktopFolder(lpsfDeskTop)) then exit;
  swPath:= Path;
  if SUCCEEDED(lpsfDeskTop.ParseDisplayName(0, nil, PWideChar(swPath), ulEaten, lpifq, ulAttribs)) then
    Result:= lpifq;
end;

function GetLastlpi(lpifq: PItemIdList): PItemIDList;
var
  pidlTemp: PItemIdList;
begin
  Result:= nil;
  if not Assigned(lpifq) then exit;
  pidlTemp:= lpifq;
  while pidlTemp <> nil do begin
    pidlTemp:= GetNextItemID(lpifq);
    if Assigned(pidlTemp) then
      lpifq:= pidlTemp;
  end;
  Result:= ConcatPidls(nil, lpifq);
end;

function GetlpiFromPath(const Path: string; var lpi: PItemIDList): BOOL;
var
  ppmem: IMalloc;
  lpifq: PItemIDList;
begin
  Result:= FALSE;
  if FAILED(ShGetMalloc(ppmem))then exit;
  lpifq:= GetPidlfqFromPath(Path);
  if Assigned(lpifq) then begin
    lpi:= GetLastlpi(lpifq);
    Result:= Assigned(lpi);
    ppmem.free(lpifq);
  end;
end;

function GetShellFolderFromPath(const Path: string; var lpsf: IShellFolder): BOOL;
var
  ppmem: IMalloc;
  lpsfsub, lpsfdesktop: IShellFolder;
  lpifq, pidlCopy, pidl: PItemIDList;
  i, ItemCount: UINT;
begin
  Result:= FALSE;
  if (Path = '') or FAILED(ShGetMalloc(ppmem)) or FAILED(SHGetDesktopFolder(lpsfDeskTop)) then exit;
  lpifq:= GetPidlfqFromPath(Path);
  if not Assigned(lpifq) then exit;
  ItemCount:= GetItemCount(lpifq);
  if ItemCount > 1 then begin
    pidl:= lpifq;
    for i:= 1 to ItemCount-1 do begin
      pidlCopy:= CopyItemID(pidl);
      if FAILED(lpsfDeskTop.BindToObject(pidlCopy, nil, IID_IShellFolder, Pointer(lpsfsub))) then begin
        ppmem.free(pidlCopy);
        exit;
      end;
      lpsfdesktop:= lpsfsub;
      ppmem.free(pidlCopy);
      pidl:= GetNextItemID(pidl);
    end;
    ppmem.free(lpifq);
    lpsf:= lpsfDeskTop;
    Result:= Assigned(lpsf);
  end;
end;

function GetData(const lpifq: PItemIDList; var lpsf: IShellFolder; var lpi: PItemIDList): BOOL;
var
  ppmem: IMalloc;
  lpsfsub, lpsfdesktop: IShellFolder;
  pidlCopy, pidl: PItemIDList;
  i, ItemCount: UINT;
begin
  Result:= FALSE;
  if not Assigned(lpifq) or FAILED(ShGetMalloc(ppmem)) or FAILED(SHGetDesktopFolder(lpsfDeskTop)) then exit;
  ItemCount:= GetItemCount(lpifq);
  if ItemCount < 2 then exit;
  pidl:= lpifq;
  for i:= 1 to ItemCount-1 do begin
    pidlCopy:= CopyItemID(pidl);
    if FAILED(lpsfDeskTop.BindToObject(pidlCopy, nil, IID_IShellFolder, Pointer(lpsfsub))) then begin
      ppmem.free(pidlCopy);
      exit;
    end;
    lpsfdesktop:= lpsfsub;
    ppmem.free(pidlCopy);
    pidl:= GetNextItemID(pidl);
  end;
  lpsf:= lpsfDeskTop;
  lpi:= CopyItemID(pidl);
  Result:= Assigned(lpsf) and Assigned(lpi);
end;

function GetDataEx(cu: integer; var lpsf: IShellFolder; var arlpi: PItemIDList; FFileNames: TStringList): BOOL;
var
  ppmem: IMalloc;
  lpi: PItemIDList;
  i: integer;
begin
  Result:= FALSE;
  lpsf:= nil;
  if FAILED(ShGetMalloc(ppmem)) or
     not GetShellFolderFromPath(FFileNames[0], lpsf)then exit;
  arlpi:= nil;
  for i:= 0 to cu-1 do begin
    if not GetlpiFromPath(FFileNames[i], lpi) then exit;
    arlpi:= ConcatPidls(arlpi, lpi);
    ppmem.free(lpi);
    if not Assigned(arlpi) then exit;
  end;
  Result:= Assigned(lpsf) and Assigned(arlpi)
end;

function isNormalPidl(ppmem: IMalloc; lpsf: IShellFolder;const lpi: PItemIDList): BOOL;
var
  lpifq: PItemIDList;
begin
  Result:= FALSE;
  lpifq:= GetFullyQualPidl(lpsf,lpi);
  if lpifq<>nil then begin
    Result:= TRUE;
    ppmem.free(lpifq);
  end;
end;

  {  ContextMenuEx  }

constructor TContextMenuEx.Create(AOwner: TComponent);
begin
  FFileNames:= TStringList.Create;
  inherited Create(AOwner);
end;

destructor TContextMenuEx.Destroy;
begin
  FFileNames.Free;
  inherited Destroy;
end;

procedure TContextMenuEx.SetFileNames(Value: TStringList);
begin
  if Assigned(Value) then FFileNames.Assign(Value);
end;

function TContextMenuEx.isMenu(hcnMenu: HMENU; ckMenu: string; index: Integer): integer;
var
  j, i: integer;
  MenuState: UINT;
  szMenu: string;
  buf : array [0..255] of Char;
begin
  Result:= -1;
  j:= GetMenuItemCount(hcnMenu);
  for i:= 1 to j do begin
    MenuState:= GetMenuState(hcnMenu, i-1, MF_BYPOSITION);
    if (MenuState and (MF_SEPARATOR or MF_GRAYED or MF_DISABLED)) = 0 then begin
      if GetMenuString(hcnMenu,i-1, buf, Sizeof(Buf)-1, MF_BYPOSITION) <> $FFFFFFFF then
        szMenu:= StrPas(buf) else
        szMenu:='';
      if Pos(ckMenu, szMenu) = index then begin
        Result:= i;
        Break;
      end;
    end;
  end;
end;

  {  quickCommand Section  }

function TContextMenuEx.quickCommand(OwnerHandle: HWND; const Path: string;
                                     X, Y: Integer; qCmd: TcmCmdType): BOOL;
var
  ppmem: IMalloc;
  lpsf: IShellFolder;
  lpifq, lpi: PItemIDList;
  P: TPoint;
begin
  Result:= FALSE;
  if (OwnerHandle = 0) or FAILED(ShGetMalloc(ppmem)) then exit;
  lpifq:= GetPidlfqFromPath(Path);
  if Assigned(lpifq) then begin
    if GetData(lpifq, lpsf, lpi) then begin
      P.X:= X; P.Y:= Y;
      Windows.ClientToScreen(OwnerHandle, P);
      if CMCommand(OwnerHandle, lpsf, lpi, p, qCmd) then
         Result:= TRUE  {   SUCCEEDED   }
      else begin
        {  FALSE }
      end;
    end;
    if Assigned(lpi) then ppmem.free(lpi);
    if Assigned(lpifq) then ppmem.free(lpifq);
  end;
end;

function TContextMenuEx.CMCommand(OwnerHandle: HWND; lpsf: IShellFolder;
                                                     lpi: PItemIDList; p:TPoint; idCmd: TcmCmdType): BOOL;
const
  CmdTypes: array[TcmCmdType] of Integer = (CMIDCMD_LINK, CMIDCMD_DELETE, CMIDCMD_PROPERTIES, CMIDCMD_CUT,
                                            CMIDCMD_COPY, CMIDCMD_PASTE);
  SfgaoTypes: array[TcmCmdType] of Integer = (SFGAO_CANLINK, SFGAO_CANDELETE, SFGAO_HASPROPSHEET, SFGAO_CANMOVE,
                                              SFGAO_CANCOPY, 0);
var
  lpcm: IContextMenu;
  hcnMenu: HMENU;
  cmi: TCMInvokeCommandInfo;
  i: Integer;
  cidl, rgfInOut: UINT;
  CanCommand: BOOL;
begin
  Result:= FALSE;
  if (OwnerHandle = 0) or not Assigned(lpsf ) or not Assigned(lpi) then exit;
  if not((idCmd >= ctLink) and (idCmd <= ctPaste)) then exit;
  i:= 1; cidl:= 1;
  rgfInOut:= SFGAO_CAPABILITYMASK or SFGAO_DISPLAYATTRMASK or SFGAO_CONTENTSMASK;
  if NOERROR <> lpsf.GetAttributesOf(cidl,lpi,rgfInOut) then exit;
  if idCmd <> ctPaste then
    if not((rgfInOut and SfgaoTypes[idCmd]) <> 0) then exit;
  CanCommand:= TRUE;
  if SUCCEEDED(lpsf.GetUIObjectOf(OwnerHandle, i, lpi, IID_IContextMenu, nil, Pointer(lpcm))) then begin
    hcnMenu:= CreatePopupMenu();
    if hcnMenu <> 0 then begin
      if SUCCEEDED(lpcm.QueryContextMenu(hcnMenu, 0, 1, $7fff, CMF_EXPLORE)) then begin
        if idCmd = ctPaste then
          CanCommand:= -1 <> isMenu(hcnMenu, CK_MENU_PASTE, CK_MENU_PASTE_INDEX);
        if CanCommand then begin
          with cmi do begin
            cbSize       := sizeof(TCMInvokeCommandInfo);
            fMask        := 0;
            hwnd         := OwnerHandle;
            lpVerb       := MakeIntResource(CmdTypes[idCmd] - 1);
            lpParameters := nil;
            lpDirectory  := nil;
            nShow        := SW_SHOWNORMAL;
            dwHotKey     := 0;
            hIcon        := 0;
          end;
          if SUCCEEDED(lpcm.InvokeCommand(cmi)) then
            Result:= TRUE  {   SUCCEEDED   }
          else
            Application.MessageBox(' InvokeCommand failed! ',
                        ' TContextMenuEx component version ' + DRPCOMEXVersion ,
                        MB_OK+ MB_ICONINFORMATION);
        end;
      end;
      DestroyMenu(hcnMenu);
    end;
  end;
end;

  {  DoMenu Section  }

function TContextMenuEx.DoMenu(OwnerHandle: HWND; const Path: string; X, Y: Integer): BOOL;
begin
  Result:= FALSE;
  if OwnerHandle = 0 then exit;
  FFileNames.Clear;
  FFileNames.Add(Path);
  if DoMenuEx(OwnerHandle, X, Y) then
    Result:= TRUE  {   SUCCEEDED   }
  else begin
        {  FALSE or ContextMenu Cancel  }
  end;
end;

function TContextMenuEx.DoMenuEx(OwnerHandle: HWND; X, Y: Integer): BOOL;
var
  ppmem: IMalloc;
  lpsf: IShellFolder;
  arlpi: PItemIDList;
  P: TPoint;
  cu: integer;
begin
  Result:= FALSE;
  if (OwnerHandle = 0) or FAILED(ShGetMalloc(ppmem)) then exit;
  cu:= FFileNames.Count;
  if (cu <= 0) or (cu > MAX_PIDL)then exit;
  if GetDataEx(cu, lpsf, arlpi, FFileNames) then begin
    P.X:= X; P.Y:= Y;
    Windows.ClientToScreen(OwnerHandle, P);
    if ContextMenu(OwnerHandle, lpsf, arlpi, cu , p) then
      Result:= TRUE  {   SUCCEEDED   }
    else begin
       {  FALSE or ContextMenu Cancel  }
    end;
  end;
  if Assigned(arlpi) then ppmem.free(arlpi);
end;

function TContextMenuEx.ContextMenu(OwnerHandle: HWND; lpsf: IShellFolder; lpi: PItemIdList;
                                                                           ipi: integer; p:TPoint): BOOL;

{  function AddSendToMenu(ppmem: IMalloc; hSTMenu: hMenu; lpsf: IShellFolder; lpi: PItemIDList): BOOL;
  var
    j: integer;
    hSendToMenu: hMenu;
    lpe: IEnumIdList;
    lpist: PItemIDList;
    ulFetched: ULONG;
    lpsfst: IShellFolder;
    szName: string;
  begin
    Result:= FALSE;
    hSendToMenu:= 0;
    if FAILED(lpsf.BindToObject(lpi, nil, IID_ISHELLFOLDER, pointer(lpsfst))) then exit;
    ppmem.Free(lpi);
    if SUCCEEDED(lpsfst.EnumObjects(OwnerHandle, SHCONTF_NONFOLDERS, lpe)) then begin
      j:= 0;
      while lpe.Next(0, lpist, ulFetched) = S_OK do begin
        GetNames(lpsfst, lpist, SHGDN_NORMAL, szName);
        AppendMenu(hSendToMenu, MF_STRING, ID_SENDTO_FIRST + j, pChar(szName));
        inc(j);
        ppmem.Free(lpist);
        if j> MAX_SENDTO then Break;
      end;
        Result:= j <= MAX_SENDTO;
    end;
  end;
 }
  function SetSendToMenu(Menu: HMenu; lpsfdesktop: IShellFolder; ppmem: IMalloc): BOOL;
  var
    MenuIndex: integer;
    i, j: integer;
    hSendToMenu: hMenu;
    lpe: IEnumIdList;
    lpi, lpist: PItemIDList;
    ulFetched: ULONG;
    lpsfst: IShellFolder;
    szName: string;
  begin
    Result:= FALSE;
    if Menu = 0 then exit;
    hSendToMenu:= 0;
    MenuIndex:= -1;
    i:= isMenu(Menu, CK_MENU_SENDTO, CK_MENU_SENDTO_INDEX);
    if i = -1 then
    {  Add to version 2.05  }
      i:= isMenu(Menu, CK_MENU_IE4_SENDTO, CK_MENU_SENDTO_INDEX);
    if i <> -1 then begin
      hSendToMenu:= GetSubMenu(menu, i-1);
      MenuIndex:= i-1;
    end;
    if (MenuIndex >= 0) and (hSendToMenu <> 0) then begin
      if FAILED(SHGetSpecialFolderLocation(OwnerHandle, CSIDL_SENDTO, lpi)) then exit;
      if SUCCEEDED(lpsfdesktop.BindToObject(lpi, nil, IID_ISHELLFOLDER, pointer(lpsfst))) then begin
        if SUCCEEDED(lpsfst.EnumObjects(OwnerHandle, SHCONTF_NONFOLDERS, lpe)) then begin
          j:= 0;
          while lpe.Next(0, lpist, ulFetched) = S_OK do begin
            GetNames(lpsfst, lpist, SHGDN_NORMAL, szName);
            AppendMenu(hSendToMenu, MF_STRING, ID_SENDTO_FIRST + j, pChar(szName));
            inc(j);
            ppmem.Free(lpist);
            if j> MAX_SENDTO then Break;
          end;
          Result:= (i > 0) and  (j <= MAX_SENDTO);
        end;
      end;
      ppmem.Free(lpi);
    end;
    if hSendToMenu <> 0 then DeleteMenu(hSendToMenu, 0, MF_BYPOSITION);
  end;

  function PasteToSendTo(OwnerHandle: HWND; lpsfdesktop: IShellFolder; SendToIndex: Integer;
                                                                       p:TPoint; ppmem: IMalloc): BOOL;
  var
    lpsfst: IShellFolder;
    lpist, pidl: pItemIdList;
    lpe: IEnumIdList;
    j: Integer;
    ulFetched: ULONG;
  begin
    Result:= FALSE;
    if FAILED(SHGetSpecialFolderLocation(OwnerHandle, CSIDL_SENDTO, pidl)) then exit;
    if SUCCEEDED(lpsfdesktop.BindToObject(pidl, nil, IID_ISHELLFOLDER, pointer(lpsfst))) then begin
      if SUCCEEDED(lpsfst.EnumObjects(OwnerHandle, SHCONTF_NONFOLDERS, lpe)) then begin
        j:= 0;
        while lpe.Next(0, lpist, ulFetched) = S_OK do begin
          if j = SendToIndex then begin
            Result:= CMCommand(OwnerHandle, lpsfst, lpist, p, ctPaste);
            ppmem.Free(lpist);
            Break;
          end;
          inc(j);
          ppmem.Free(lpist);
          if j> MAX_SENDTO then Break;
        end;
      end;
      ppmem.Free(pidl);
    end;
  end;

var
  lpcm: IContextMenu;
  hcnMenu: HMENU;
  idCmd: Integer;
  cmi: TCMInvokeCommandInfo;
  i: Integer;
  lpsfdesktop: IShellFolder;
  ppmem: IMalloc;
  SendToIndex: Integer;
  SendToOn: BOOL;
  arlpi: array [0..MAX_PIDL-1] of PItemIDList;
begin
  Result:= FALSE;
  if (OwnerHandle = 0) or (lpsf = nil) or (lpi = nil) or (ipi <= 0) or (ipi > MAX_PIDL) then exit;
  if FAILED(SHGetDesktopFolder(lpsfDeskTop)) or FAILED(ShGetMalloc(ppmem)) then exit;
  SendToOn:= FALSE;
  SendToIndex:= -1;
  for i:= 0 to ipi-1 do begin
    if lpi = nil then exit;
    arlpi[i]:= CopyItemID(lpi);
    lpi:= GetNextItemID(lpi);
  end;
  if SUCCEEDED(lpsf.GetUIObjectOf(OwnerHandle, ipi, arlpi[0], IID_IContextMenu, nil, Pointer(lpcm))) then begin
    hcnMenu:= CreatePopupMenu();
    if hcnMenu<>0 then begin
      if SUCCEEDED(lpcm.QueryContextMenu(hcnMenu, 0, 1, $7fff, CMF_EXPLORE)) then begin
        if SetSendToMenu(hcnMenu, lpsfdesktop, ppmem) then
          SendToOn:= TRUE;
        idCmd:= integer(TrackPopupMenu(hcnMenu, TPM_LEFTALIGN or TPM_RETURNCMD or
                        TPM_RIGHTBUTTON, p.x, p.y, 0, OwnerHandle, nil));
        if SendToOn then
          if (idCmd >= ID_SENDTO_FIRST) and (idCmd <= ID_SENDTO_LAST) then begin
            SendToIndex:= (idCmd - ID_SENDTO_FIRST);
            idCmd:= CMIDCMD_COPY;
          end else
            SendToOn:=  FALSE;
        if idCmd <> 0 then begin
          with cmi do begin
            cbSize       := sizeof(TCMInvokeCommandInfo);
            fMask        := 0;
            hwnd         := OwnerHandle;
            lpVerb       := MakeIntResource(idCmd-1);
            lpParameters := nil;
      	    lpDirectory  := nil;
            nShow        := SW_SHOWNORMAL;
            dwHotKey     := 0;
            hIcon        := 0;
          end;
          if SUCCEEDED(lpcm.InvokeCommand(cmi)) then
            Result:= TRUE  {   SUCCEEDED   }
          else
            Application.MessageBox(' InvokeCommand failed! ',
                                  ' TContextMenuEx component version '+ DRPCOMEXVersion,
                                  MB_OK+ MB_ICONINFORMATION);
        end;
        if Result and SendToOn then
          Result:= PasteToSendTo(OwnerHandle, lpsfdesktop, SendToIndex, p, ppmem);
      end;
      DestroyMenu(hcnMenu);
    end;
  end;
  for i:= 0 to ipi-1 do
    if arlpi[i] <> nil then ppmem.Free(arlpi[i]);
end;

    { TDropSourceObject class }

type
  TDropSourceObject = class(TInterfacedObject, IDropSource)
  public
    constructor Create;
    function QueryContinueDrag(fEscapePressed: BOOL; grfKeyState: Longint): HResult; stdcall;
    function GiveFeedback(dwEffect: Longint): HResult;stdcall;
  end;

constructor TDropSourceObject.Create;
begin
  inherited Create;
end;

function TDropSourceObject.QueryContinueDrag(fEscapePressed: BOOL;
      grfKeyState: Longint): HResult;
begin
  if fEscapePressed then
    Result:= DRAGDROP_S_CANCEL else
  if not(grfKeyState and MK_LBUTTON<>0) and not(grfKeyState and MK_RBUTTON<>0) then
    Result:= DRAGDROP_S_DROP else
    Result:= NOERROR;
end;

function TDropSourceObject.GiveFeedback(dwEffect: Longint): HResult;
begin
  Result:= DRAGDROP_S_USEDEFAULTCURSORS;
end;

   {  TDropSourceEx  }

constructor TDropSourceEx.Create(AOwner: TComponent);
begin
   FFileNames:= TStringList.Create;
  inherited Create(AOwner);
end;

destructor TDropSourceEx.Destroy;
begin
  FFileNames.Free;
  inherited Destroy;
end;

procedure TDropSourceEx.SetFileNames(Value: TStringList);
begin
  if Value <> nil then
    FFileNames.Assign( Value );
end;

  {  DoDrop Section  }

procedure TDropSourceEx.DoDrop(OwnerHandle: HWND; const Path: string);
begin
  if OwnerHandle = 0 then exit;
  FFileNames.Clear;
  FFileNames.Add(Path);
  DoDropEx(OwnerHandle);
end;

procedure TDropSourceEx.DoDropEx(OwnerHandle: HWND);
var
  ppmem: IMalloc;
  lpsf: IShellFolder;
  arlpi: PItemIDList;
  cu: integer;
begin
  if (OwnerHandle = 0) or FAILED(ShGetMalloc(ppmem)) then exit;
  if (FFileNames.Count <= 0) or (FFileNames.Count > MAX_PIDL) then exit;
  cu:= FFileNames.Count;
  if GetDataEx(cu, lpsf, arlpi, FFileNames) then
    DoDropSource(OwnerHandle, lpsf, arlpi, cu);
  if arlpi <> nil then ppmem.free(arlpi);
end;

procedure TDropSourceEx.DoDropSource(OwnerHandle: HWND; lpsf: IShellFolder; lpi: PItemIDList; ipi: integer);
var
  ppmem: IMalloc;
  lpdo: IDataObject;
  lpds: IDropSource;
  prgfInOut: Pointer;
  dwEffect: Longint;
  i: integer;
  arlpi: array [0..MAX_PIDL-1] of PItemIDList;
begin
  if (OwnerHandle = 0) or (lpsf = nil) or (lpi = nil) or FAILED(ShGetMalloc(ppmem)) then exit;
  if (ipi <= 0) or (ipi > MAX_PIDL)then exit;
  prgfInOut:= nil;
  for i:= 0 to ipi-1 do begin
    if lpi = nil then exit;
    arlpi[i]:= CopyItemID(lpi);
    lpi:= GetNextItemID(lpi);
  end;
  if SUCCEEDED(lpsf.GetUIObjectOf(OwnerHandle, ipi, arlpi[0], IDataObject, prgfInOut, Pointer(lpdo))) then begin
    lpds:= IDropSource(TDropSourceObject.Create);
    if lpds <> nil then begin
      DoDragDrop(lpdo, lpds, DROPEFFECT_COPY or DROPEFFECT_MOVE or DROPEFFECT_LINK, dwEffect);
      lpds:= nil;           
    end;
  end;
  for i:= 0 to ipi-1 do
    if arlpi[i] <> nil then ppmem.Free(arlpi[i]);
end;

initialization
begin
  OleInitialize(nil);
end;

finalization
begin
  OleUninitialize;
end;

end.
